GentlemensGame/GentlemensGame/Models/Game.cs
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations.Schema;
using System.Linq;
using System.Threading.Tasks;

namespace GentlemensGame.Models
{
    public class Game
    {
        public int Id { get; set; }
        public string Name { get; set; }
        public string WinnerId { get; set; }
        public bool FinishedGame { get; set; }
       
        [NotMapped]
        public string FullName {
            get
            {
                return Id + ". " + Name;
            }
        }

        public List<CardDeck> CardDecks { get; set; }
    }
}

GentlemensGame/GentlemensGame/Controllers/GamesController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
using Microsoft.EntityFrameworkCore;
using GentlemensGame.Data;
using GentlemensGame.Models;
using Microsoft.AspNetCore.Identity;
using GentlemensGame.Services;

namespace GentlemensGame.Controllers
{
    public class GamesController : Controller
    {
        private readonly ApplicationDbContext _context;
        private readonly UserManager<ApplicationUser> _userManager;
        private readonly IGameService _gameService;

        public GamesController(UserManager<ApplicationUser> userManager, ApplicationDbContext context, IGameService gameService)
        {
            _context = context;
            _userManager = userManager;
            _gameService = gameService;
        }

        // GET: Games/
        public async Task<IActionResult> Index()
        {
            ViewData["GameId"] = new SelectList(_context.Game, "Id", "FullName");
            return View(await _context.Game.ToListAsync());

        }

        public async Task<IActionResult> Game(int? id)
        {
            ViewBag.GameId = _context.Game.FirstOrDefault(x => x.Id == id);

            return await PlayerHand((int)id);

        }

       

        public async Task<IActionResult> DelCardAddTuck([Bind("Id,GamePlayerId, CardId")] int cardId)
        {
            await _gameService.DeleteCardFromHandAndAddToTuck(cardId);
            return View();
        }

       


        [HttpPost]
        //[ValidateAntiForgeryToken]
        public async Task<IActionResult> Create([Bind("Id,Name,WinnerId")] Game game)
        {

            _context.Add(game);
            await _context.SaveChangesAsync();
            return Json(game);

        }




        [HttpPost]
        public async Task <IActionResult> AddGamePlayer([Bind("Id,UserId,GameId")] int id)
        {
            await _gameService.AddPlayer(id);
            return View();

        }

        private async Task<IActionResult> PlayerHand(int? id)
        {
            if (id != null)
            {
                if (_context.CardDeck.FirstOrDefault(x => x.GameId == id) != null)
                {
                    var playerHand = _gameService.MakePlayerHand((int)id);
                    return View(playerHand);
                }

                var cards = await _context.Card.OrderBy(x => Guid.NewGuid())
                    .Select(x => new CardDeck() { CardId = x.Id, GameId = (int)id }).ToListAsync();

                _context.AddRange(cards);
                await _context.SaveChangesAsync();

                var initialHand = _gameService.MakePlayerHand((int)id);
                return View(initialHand);
            }


            return View();
        }



    }   
}

GentlemensGame/GentlemensGame/Views/Games/Create.cshtml
@model GentlemensGame.Models.Game

@{
    ViewData["Title"] = "Create";
}

<h2>Create</h2>

<h4>Game</h4>
<hr />
<div class="row">
    <div class="col-md-4">
        <form asp-action="Create">
            <div asp-validation-summary="ModelOnly" class="text-danger"></div>
            <div class="form-group">
                <label asp-for="WinnerId" class="control-label"></label>
                <input asp-for="WinnerId" class="form-control" />
                <span asp-validation-for="WinnerId" class="text-danger"></span>
            </div>
            <div class="form-group">
                <input type="submit" value="Create" class="btn btn-default" />
            </div>
        </form>
    </div>
</div>

<div>
    <a asp-action="Index">Back to List</a>
</div>

@section Scripts {
    @{await Html.RenderPartialAsync("_ValidationScriptsPartial");}
}

GentlemensGame/GentlemensGame/Views/Games/Delete.cshtml
@model GentlemensGame.Models.Game

@{
    ViewData["Title"] = "Delete";
}

<h2>Delete</h2>

<h3>Are you sure you want to delete this?</h3>
<div>
    <h4>Game</h4>
    <hr />
    <dl class="dl-horizontal">
        <dt>
            @Html.DisplayNameFor(model => model.WinnerId)
        </dt>
        <dd>
            @Html.DisplayFor(model => model.WinnerId)
        </dd>
    </dl>
    
    <form asp-action="Delete">
        <input type="hidden" asp-for="Id" />
        <input type="submit" value="Delete" class="btn btn-default" /> |
        <a asp-action="Index">Back to List</a>
    </form>
</div>

GentlemensGame/GentlemensGame/Views/Games/Details.cshtml
@model GentlemensGame.Models.Game

@{
    ViewData["Title"] = "Details";
}

<h2>Details</h2>

<div>
    <h4>Game</h4>
    <hr />
    <dl class="dl-horizontal">
        <dt>
            @Html.DisplayNameFor(model => model.WinnerId)
        </dt>
        <dd>
            @Html.DisplayFor(model => model.WinnerId)
        </dd>
    </dl>
</div>
<div>
    <a asp-action="Edit" asp-route-id="@Model.Id">Edit</a> |
    <a asp-action="Index">Back to List</a>
</div>

GentlemensGame/GentlemensGame/Views/Games/Edit.cshtml
@model GentlemensGame.Models.Game

@{
    ViewData["Title"] = "Edit";
}

<h2>Edit</h2>

<h4>Game</h4>
<hr />
<div class="row">
    <div class="col-md-4">
        <form asp-action="Edit">
            <div asp-validation-summary="ModelOnly" class="text-danger"></div>
            <input type="hidden" asp-for="Id" />
            <div class="form-group">
                <label asp-for="WinnerId" class="control-label"></label>
                <input asp-for="WinnerId" class="form-control" />
                <span asp-validation-for="WinnerId" class="text-danger"></span>
            </div>
            <div class="form-group">
                <input type="submit" value="Save" class="btn btn-default" />
            </div>
        </form>
    </div>
</div>

<div>
    <a asp-action="Index">Back to List</a>
</div>

@section Scripts {
    @{await Html.RenderPartialAsync("_ValidationScriptsPartial");}
}

GentlemensGame/GentlemensGame/Views/Games/Game.cshtml
@using Microsoft.AspNetCore.Identity
@using GentlemensGame.Areas.Identity.Pages.Account

@model IEnumerable<GentlemensGame.Models.Hand>

@inject SignInManager<ApplicationUser> SignInManager
@inject UserManager<ApplicationUser> UserManager

<head>
    <style>
        imgA {
            margin: 15px;
        }

        .selected {
            transform: scale(1.1,1.1);
        }
        #messagesList{
            height: 200px;
        }
    </style>
</head>

@{
    ViewData["Title"] = "Index";

}

<h1 id="gameName">Game @ViewBag.GameId.Id</h1>
<h2>Round 1</h2>

<div id="messagesList"></div>
<div id="userList"> </div>

<br>

<div id="@UserManager.GetUserAsync(User).Result.NickName">
    
    @foreach (var item in Model)
    {

        string card = item.CardId + ".svg";

        <img src="~/images/Cards/@card" height="150" />
    }

</div>



<div class="container">
    <div class="row">
        <div class="col-6">
            <input type="hidden" id="userInput" value="@UserManager.GetUserAsync(User).Result.NickName" />
            <input type="hidden" id="messageInput" value="" />
            <input type="hidden" id="sendButton" value="Play Card" />
        </div>
    </div>
</div>

<br>



@section Scripts
    {
    <script src="~/lib/signalr/dist/browser/signalr.js"></script>
    <script src="~/js/chat.js"></script>
    <script>
        var isLoaded = false;
        var hasMove = true;

        $('img').mouseenter(function () {
            $(this).addClass('selected');
        });
        $('img').mouseleave(function () {
            $('.selected').removeClass('selected');
            $(this).addClass('imgA');
        });

        $('img').bind("click", imgClick);

        function imgClick() {
            var source = $(this).attr('src');


            $(document).ready(function () {
                $("input[id=messageInput]").val(source);

            });
            $(document).ready(function () {
                $("input[id=sendButton]").click();
            });
            $(this).remove();

            var id = $(this).attr('src').replace("/images/Cards/", "").replace(".svg", "");
                $.ajax({
                    type: 'POST',
                    url: '@Url.Action("DelCardAddTuck", "Games")',
                    data: { cardId: id },

                    });


         }



        function tuck() {
            var cardsOnTable = $('#messagesList').children().length;
            if (cardsOnTable == 3) {
                setTimeout(function () {
                    $('#messagesList').children().remove();
                    $('img').bind("click", imgClick)
                }, 3000);


            }
        }





    </script>
}

GentlemensGame/GentlemensGame/Views/Games/Index.cshtml
@model IEnumerable<GentlemensGame.Models.Game>

@{
    ViewData["Title"] = "Index";
}
<style>
    div.row {
        margin-top: 50px;
    }

    select {
        width: auto;
        text-align: center;
        width: 100%;
    }

    center {
        margin: auto;
        width: 60%;
        padding: 20px;
        box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
    }

    .hideform {
        display: none;
    }
</style>



@section Scripts
    {

    <script>
            $('#joinGame').on('click', function () {
                var gameId = $('#gameSelect option:selected').val();
                $.ajax({
                    type: 'POST',
                    url: '@Url.Action("AddGamePlayer", "Games")',
                    data: { id : gameId },
                });
                window.location.replace("Games/Game/" + gameId)
            })

            $('#show').on('click', function () {
                $('.center').show();
                $(this).hide();
            })

            $('#close').on('click', function () {
                $('.center').hide();
                $('#show').show();
            })
            $('#gameName').on('click', function () {         

                $.ajax({
                    type: 'POST',
                    url: '@Url.Action("Create","Games")',
                    data: {
                        name: $('#gameNameValue').val(),
                    },
                    success: function (result) {                  
                       $.ajax({
                            type: 'POST',
                           url: '@Url.Action("AddGamePlayer", "Games")',
                           data: result,
                });
                        window.location.replace("Games/Game/" + result.id)

                    }
                    

                });
             
            })


    </script>
}

<div class="row">
    <div class="col-lg-4">
        <p>Hello!</p>
        <p>Please choose lobby from table or create new.</p>
    </div>
    <div class="col-lg-4">
        <select  id="gameSelect" class="form-control" asp-items="ViewBag.GameId"></select>
    </div>
    <div class="col-lg-3">

        <div class="center hideform">
            <button id="close" style="float: right;">X</button>
            Game name:<br>
            <input type="text" name="gameName" id="gameNameValue">
            <br>
            <br>
            <input type="submit" value="Submit" id="gameName" >
        </div>
        <div>
            <button class="btn-block" id="show">Create game</button>
            <button class="btn-block" id="joinGame"> Join</button>
        </div>
    </div>
</div>